<?php

namespace InSegment\ApiCore\Models;

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;

class DeletedTransactionRecord extends SupplementaryTable
{
    /**
     * Fillable attributes
     * 
     * @var array
     */
    protected $fillable = [
        'table',
        'key_name',
        'key'
    ];
    
    /**
     * Run the migrations.
     *
     * @param array $enabledTablesToKeys
     * @param bool $inMemory
     * @param string|null $uid
     * @return void
     */
    public static function establish(array $enabledTablesToKeys, bool $inMemory, $uid = null)
    {
        Schema::create((new static([], $uid))->getTable(), function (Blueprint $table) use ($enabledTablesToKeys, $inMemory) {
            if ($inMemory) {
                $table->engine = 'MEMORY';
            }
            
            $table->enum('table', array_keys($enabledTablesToKeys));
            $table->enum('key_name', array_unique(array_values($enabledTablesToKeys)));
            $table->string('key');
            $table->index(['table'], 'deleted_transaction_records_table_index');
            $table->primary(['table', 'key_name', 'key'], 'deleted_transaction_records_primary');
        });
    }
}
