<?php

namespace InSegment\ApiCore\Traits;

use Illuminate\Support\Facades\DB;

trait SliceManagementTrait
{
    /**
     * Get slice operation UID
     * 
     * @return string
     */
    public abstract function getUID(): string;
    
    /**
     * Get schema name for transaction tables
     * 
     * @return string
     */
    public function getSchema(): string
    {
        return config('api_core.transaction_schema') ?: DB::getDatabaseName();
    }
    
    /**
     * Get count of records was written for table
     * 
     * @param string $table
     * @return int
     */
    public abstract function getWrittenCount(string $table): int;
    
    /**
     * Get count of records was inserted into table
     * 
     * @param string $table
     * @return int
     */
    public abstract function getNewCount(string $table): int;
    
}
